module MeterpreterDetection;

# Catch C++ plugin events
event meterpreter_header_detected(c: connection, dir: bool)
	{
	local message = fmt("Meterpreter detected with reason=HEADER_DETECTED, protocol=TCP, os=ANY");
	MeterpreterDetection::log_a_notice(c, message,
	    MeterpreterDetection::Meterpreter_Detected, ! dir);
	}

event meterpreter_header_content(c: connection, guid: string, staged: bool,
    encrypted: bool)
	{
	local message = fmt("Meterpreter header detected with protocol=TCP in connection UID=%s, guid=%s, staged=%s"
	    + "encrypted=%s", c$uid, string_to_ascii_hex(guid), staged, encrypted);
	MeterpreterDetection::log_a_notice(c, message,
	    MeterpreterDetection::Meterpreter_Header_Detected, T);
	}
